test-lib: rearrange start/end of test_expect_* and test_skip
[git/mingw/j6t.git] / t / test-lib.sh
blob0985ca5eb7a4ff2c496ac90732b1b28ad48116bb
1 #!/bin/sh
3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # Keep the original TERM for say_color
19 ORIGINAL_TERM=$TERM
21 # Test the binaries we have just built. The tests are kept in
22 # t/ subdirectory and are run in 'trash directory' subdirectory.
23 if test -z "$TEST_DIRECTORY"
24 then
25 # We allow tests to override this, in case they want to run tests
26 # outside of t/, e.g. for running tests on the test library
27 # itself.
28 TEST_DIRECTORY=$(pwd)
30 if test -z "$TEST_OUTPUT_DIRECTORY"
31 then
32 # Similarly, override this to store the test-results subdir
33 # elsewhere
34 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
36 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
38 ################################################################
39 # It appears that people try to run tests without building...
40 "$GIT_BUILD_DIR/git" >/dev/null
41 if test $? != 1
42 then
43 echo >&2 'error: you do not seem to have built git yet.'
44 exit 1
47 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
48 export PERL_PATH SHELL_PATH
50 # if --tee was passed, write the output not only to the terminal, but
51 # additionally to the file test-results/$BASENAME.out, too.
52 case "$GIT_TEST_TEE_STARTED, $* " in
53 done,*)
54 # do not redirect again
56 *' --tee '*|*' --va'*)
57 mkdir -p test-results
58 BASE=test-results/$(basename "$0" .sh)
59 (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
60 echo $? > $BASE.exit) | tee $BASE.out
61 test "$(cat $BASE.exit)" = 0
62 exit
64 esac
66 # For repeatability, reset the environment to known value.
67 LANG=C
68 LC_ALL=C
69 PAGER=cat
70 TZ=UTC
71 TERM=dumb
72 export LANG LC_ALL PAGER TERM TZ
73 EDITOR=:
74 # A call to "unset" with no arguments causes at least Solaris 10
75 # /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
76 # deriving from the command substitution clustered with the other
77 # ones.
78 unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
79 my @env = keys %ENV;
80 my $ok = join("|", qw(
81 TRACE
82 DEBUG
83 USE_LOOKUP
84 TEST
85 .*_TEST
86 PROVE
87 VALGRIND
88 UNZIP
89 PERF_
90 ));
91 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
92 print join("\n", @vars);
94 unset XDG_CONFIG_HOME
95 GIT_AUTHOR_EMAIL=author@example.com
96 GIT_AUTHOR_NAME='A U Thor'
97 GIT_COMMITTER_EMAIL=committer@example.com
98 GIT_COMMITTER_NAME='C O Mitter'
99 GIT_MERGE_VERBOSITY=5
100 GIT_MERGE_AUTOEDIT=no
101 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
102 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
103 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
104 export EDITOR
106 # Add libc MALLOC and MALLOC_PERTURB test
107 # only if we are not executing the test with valgrind
108 if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
109 test -n "$TEST_NO_MALLOC_CHECK"
110 then
111 setup_malloc_check () {
112 : nothing
114 teardown_malloc_check () {
115 : nothing
117 else
118 setup_malloc_check () {
119 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
120 export MALLOC_CHECK_ MALLOC_PERTURB_
122 teardown_malloc_check () {
123 unset MALLOC_CHECK_ MALLOC_PERTURB_
127 # Protect ourselves from common misconfiguration to export
128 # CDPATH into the environment
129 unset CDPATH
131 unset GREP_OPTIONS
132 unset UNZIP
134 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
135 1|2|true)
136 echo "* warning: Some tests will not work if GIT_TRACE" \
137 "is set as to trace on STDERR ! *"
138 echo "* warning: Please set GIT_TRACE to something" \
139 "other than 1, 2 or true ! *"
141 esac
143 # Convenience
145 # A regexp to match 5 and 40 hexdigits
146 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
147 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
149 # Zero SHA-1
150 _z40=0000000000000000000000000000000000000000
152 # Line feed
153 LF='
156 export _x05 _x40 _z40 LF
158 # Each test should start with something like this, after copyright notices:
160 # test_description='Description of this test...
161 # This test checks if command xyzzy does the right thing...
163 # . ./test-lib.sh
164 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
165 TERM=$ORIGINAL_TERM &&
166 export TERM &&
167 [ -t 1 ] &&
168 tput bold >/dev/null 2>&1 &&
169 tput setaf 1 >/dev/null 2>&1 &&
170 tput sgr0 >/dev/null 2>&1
171 ) &&
172 color=t
174 while test "$#" -ne 0
176 case "$1" in
177 -d|--d|--de|--deb|--debu|--debug)
178 debug=t; shift ;;
179 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
180 immediate=t; shift ;;
181 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
182 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
183 -h|--h|--he|--hel|--help)
184 help=t; shift ;;
185 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
186 verbose=t; shift ;;
187 -q|--q|--qu|--qui|--quie|--quiet)
188 # Ignore --quiet under a TAP::Harness. Saying how many tests
189 # passed without the ok/not ok details is always an error.
190 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
191 --with-dashes)
192 with_dashes=t; shift ;;
193 --no-color)
194 color=; shift ;;
195 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
196 valgrind=memcheck
197 shift ;;
198 --valgrind=*)
199 valgrind=$(expr "z$1" : 'z[^=]*=\(.*\)')
200 shift ;;
201 --tee)
202 shift ;; # was handled already
203 --root=*)
204 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
205 shift ;;
207 echo "error: unknown test option '$1'" >&2; exit 1 ;;
208 esac
209 done
211 test -n "$valgrind" && verbose=t
213 if test -n "$color"
214 then
215 say_color () {
217 TERM=$ORIGINAL_TERM
218 export TERM
219 case "$1" in
220 error)
221 tput bold; tput setaf 1;; # bold red
222 skip)
223 tput setaf 4;; # blue
224 warn)
225 tput setaf 3;; # brown/yellow
226 pass)
227 tput setaf 2;; # green
228 info)
229 tput setaf 6;; # cyan
231 test -n "$quiet" && return;;
232 esac
233 shift
234 printf "%s" "$*"
235 tput sgr0
236 echo
239 else
240 say_color() {
241 test -z "$1" && test -n "$quiet" && return
242 shift
243 printf "%s\n" "$*"
247 error () {
248 say_color error "error: $*"
249 GIT_EXIT_OK=t
250 exit 1
253 say () {
254 say_color info "$*"
257 test "${test_description}" != "" ||
258 error "Test script did not set test_description."
260 if test "$help" = "t"
261 then
262 echo "$test_description"
263 exit 0
266 exec 5>&1
267 exec 6<&0
268 if test "$verbose" = "t"
269 then
270 exec 4>&2 3>&1
271 else
272 exec 4>/dev/null 3>/dev/null
275 test_failure=0
276 test_count=0
277 test_fixed=0
278 test_broken=0
279 test_success=0
281 test_external_has_tap=0
283 die () {
284 code=$?
285 if test -n "$GIT_EXIT_OK"
286 then
287 exit $code
288 else
289 echo >&5 "FATAL: Unexpected exit with code $code"
290 exit 1
294 GIT_EXIT_OK=
295 trap 'die' EXIT
297 # The user-facing functions are loaded from a separate file so that
298 # test_perf subshells can have them too
299 . "$TEST_DIRECTORY/test-lib-functions.sh"
301 # You are not expected to call test_ok_ and test_failure_ directly, use
302 # the text_expect_* functions instead.
304 test_ok_ () {
305 test_success=$(($test_success + 1))
306 say_color "" "ok $test_count - $@"
309 test_failure_ () {
310 test_failure=$(($test_failure + 1))
311 say_color error "not ok $test_count - $1"
312 shift
313 echo "$@" | sed -e 's/^/# /'
314 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
317 test_known_broken_ok_ () {
318 test_fixed=$(($test_fixed+1))
319 say_color error "ok $test_count - $@ # TODO known breakage vanished"
322 test_known_broken_failure_ () {
323 test_broken=$(($test_broken+1))
324 say_color warn "not ok $test_count - $@ # TODO known breakage"
327 test_debug () {
328 test "$debug" = "" || eval "$1"
331 match_pattern_list () {
332 arg="$1"
333 shift
334 test -z "$*" && return 1
335 for pattern_
337 case "$arg" in
338 $pattern_)
339 return 0
340 esac
341 done
342 return 1
345 test_eval_ () {
346 # This is a separate function because some tests use
347 # "return" to end a test_expect_success block early.
348 eval </dev/null >&3 2>&4 "$*"
351 test_run_ () {
352 test_cleanup=:
353 expecting_failure=$2
354 setup_malloc_check
355 test_eval_ "$1"
356 eval_ret=$?
357 teardown_malloc_check
359 if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
360 then
361 setup_malloc_check
362 test_eval_ "$test_cleanup"
363 teardown_malloc_check
365 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
366 then
367 echo ""
369 return "$eval_ret"
372 test_start_ () {
373 test_count=$(($test_count+1))
376 test_finish_ () {
377 echo >&3 ""
380 test_skip () {
381 to_skip=
382 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
383 then
384 to_skip=t
386 if test -z "$to_skip" && test -n "$test_prereq" &&
387 ! test_have_prereq "$test_prereq"
388 then
389 to_skip=t
391 case "$to_skip" in
393 of_prereq=
394 if test "$missing_prereq" != "$test_prereq"
395 then
396 of_prereq=" of $test_prereq"
399 say_color skip >&3 "skipping test: $@"
400 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
401 : true
404 false
406 esac
409 # stub; perf-lib overrides it
410 test_at_end_hook_ () {
414 test_done () {
415 GIT_EXIT_OK=t
417 if test -z "$HARNESS_ACTIVE"
418 then
419 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
420 mkdir -p "$test_results_dir"
421 base=${0##*/}
422 test_results_path="$test_results_dir/${base%.sh}-$$.counts"
424 cat >>"$test_results_path" <<-EOF
425 total $test_count
426 success $test_success
427 fixed $test_fixed
428 broken $test_broken
429 failed $test_failure
434 if test "$test_fixed" != 0
435 then
436 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
438 if test "$test_broken" != 0
439 then
440 say_color warn "# still have $test_broken known breakage(s)"
442 if test "$test_broken" != 0 || test "$test_fixed" != 0
443 then
444 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
445 msg="remaining $test_remaining test(s)"
446 else
447 test_remaining=$test_count
448 msg="$test_count test(s)"
450 case "$test_failure" in
452 # Maybe print SKIP message
453 if test -n "$skip_all" && test $test_count -gt 0
454 then
455 error "Can't use skip_all after running some tests"
457 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
459 if test $test_external_has_tap -eq 0
460 then
461 if test $test_remaining -gt 0
462 then
463 say_color pass "# passed all $msg"
465 say "1..$test_count$skip_all"
468 test -d "$remove_trash" &&
469 cd "$(dirname "$remove_trash")" &&
470 rm -rf "$(basename "$remove_trash")"
472 test_at_end_hook_
474 exit 0 ;;
477 if test $test_external_has_tap -eq 0
478 then
479 say_color error "# failed $test_failure among $msg"
480 say "1..$test_count"
483 exit 1 ;;
485 esac
488 if test -n "$valgrind"
489 then
490 make_symlink () {
491 test -h "$2" &&
492 test "$1" = "$(readlink "$2")" || {
493 # be super paranoid
494 if mkdir "$2".lock
495 then
496 rm -f "$2" &&
497 ln -s "$1" "$2" &&
498 rm -r "$2".lock
499 else
500 while test -d "$2".lock
502 say "Waiting for lock on $2."
503 sleep 1
504 done
509 make_valgrind_symlink () {
510 # handle only executables, unless they are shell libraries that
511 # need to be in the exec-path. We will just use "#!" as a
512 # guess for a shell-script, since we have no idea what the user
513 # may have configured as the shell path.
514 test -x "$1" ||
515 test "#!" = "$(head -c 2 <"$1")" ||
516 return;
518 base=$(basename "$1")
519 symlink_target=$GIT_BUILD_DIR/$base
520 # do not override scripts
521 if test -x "$symlink_target" &&
522 test ! -d "$symlink_target" &&
523 test "#!" != "$(head -c 2 < "$symlink_target")"
524 then
525 symlink_target=../valgrind.sh
527 case "$base" in
528 *.sh|*.perl)
529 symlink_target=../unprocessed-script
530 esac
531 # create the link, or replace it if it is out of date
532 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
535 # override all git executables in TEST_DIRECTORY/..
536 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
537 mkdir -p "$GIT_VALGRIND"/bin
538 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
540 make_valgrind_symlink $file
541 done
542 # special-case the mergetools loadables
543 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
544 OLDIFS=$IFS
545 IFS=:
546 for path in $PATH
548 ls "$path"/git-* 2> /dev/null |
549 while read file
551 make_valgrind_symlink "$file"
552 done
553 done
554 IFS=$OLDIFS
555 PATH=$GIT_VALGRIND/bin:$PATH
556 GIT_EXEC_PATH=$GIT_VALGRIND/bin
557 export GIT_VALGRIND
558 GIT_VALGRIND_MODE="$valgrind"
559 export GIT_VALGRIND_MODE
560 elif test -n "$GIT_TEST_INSTALLED"
561 then
562 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
563 error "Cannot run git from $GIT_TEST_INSTALLED."
564 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
565 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
566 else # normal case, use ../bin-wrappers only unless $with_dashes:
567 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
568 if ! test -x "$git_bin_dir/git"
569 then
570 if test -z "$with_dashes"
571 then
572 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
574 with_dashes=t
576 PATH="$git_bin_dir:$PATH"
577 GIT_EXEC_PATH=$GIT_BUILD_DIR
578 if test -n "$with_dashes"
579 then
580 PATH="$GIT_BUILD_DIR:$PATH"
583 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
584 unset GIT_CONFIG
585 GIT_CONFIG_NOSYSTEM=1
586 GIT_ATTR_NOSYSTEM=1
587 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
589 if test -z "$GIT_TEST_CMP"
590 then
591 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
592 then
593 GIT_TEST_CMP="$DIFF -c"
594 else
595 GIT_TEST_CMP="$DIFF -u"
599 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
600 export GITPERLLIB
601 test -d "$GIT_BUILD_DIR"/templates/blt || {
602 error "You haven't built things yet, have you?"
605 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
606 then
607 GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
608 export GITPYTHONLIB
609 test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
610 error "You haven't built git_remote_helpers yet, have you?"
614 if ! test -x "$GIT_BUILD_DIR"/test-chmtime
615 then
616 echo >&2 'You need to build test-chmtime:'
617 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
618 exit 1
621 # Test repository
622 TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
623 test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
624 case "$TRASH_DIRECTORY" in
625 /*) ;; # absolute path is good
626 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
627 esac
628 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
629 rm -fr "$TRASH_DIRECTORY" || {
630 GIT_EXIT_OK=t
631 echo >&5 "FATAL: Cannot prepare test area"
632 exit 1
635 HOME="$TRASH_DIRECTORY"
636 export HOME
638 if test -z "$TEST_NO_CREATE_REPO"
639 then
640 test_create_repo "$TRASH_DIRECTORY"
641 else
642 mkdir -p "$TRASH_DIRECTORY"
644 # Use -P to resolve symlinks in our working directory so that the cwd
645 # in subprocesses like git equals our $PWD (for pathname comparisons).
646 cd -P "$TRASH_DIRECTORY" || exit 1
648 this_test=${0##*/}
649 this_test=${this_test%%-*}
650 if match_pattern_list "$this_test" $GIT_SKIP_TESTS
651 then
652 say_color info >&3 "skipping test $this_test altogether"
653 skip_all="skip all tests in $this_test"
654 test_done
657 # Provide an implementation of the 'yes' utility
658 yes () {
659 if test $# = 0
660 then
662 else
663 y="$*"
666 while echo "$y"
669 done
672 # Fix some commands on Windows
673 case $(uname -s) in
674 *MINGW*)
675 # Windows has its own (incompatible) sort and find
676 sort () {
677 /usr/bin/sort "$@"
679 find () {
680 /usr/bin/find "$@"
682 sum () {
683 md5sum "$@"
685 # git sees Windows-style pwd
686 pwd () {
687 builtin pwd -W
689 # no POSIX permissions
690 # backslashes in pathspec are converted to '/'
691 # exec does not inherit the PID
692 test_set_prereq MINGW
693 test_set_prereq NOT_CYGWIN
694 test_set_prereq SED_STRIPS_CR
696 *CYGWIN*)
697 test_set_prereq POSIXPERM
698 test_set_prereq EXECKEEPSPID
699 test_set_prereq NOT_MINGW
700 test_set_prereq CYGWIN
701 test_set_prereq SED_STRIPS_CR
704 test_set_prereq POSIXPERM
705 test_set_prereq BSLASHPSPEC
706 test_set_prereq EXECKEEPSPID
707 test_set_prereq NOT_MINGW
708 test_set_prereq NOT_CYGWIN
710 esac
712 ( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
713 test -z "$NO_PERL" && test_set_prereq PERL
714 test -z "$NO_PYTHON" && test_set_prereq PYTHON
715 test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
716 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
718 # Can we rely on git's output in the C locale?
719 if test -n "$GETTEXT_POISON"
720 then
721 GIT_GETTEXT_POISON=YesPlease
722 export GIT_GETTEXT_POISON
723 test_set_prereq GETTEXT_POISON
724 else
725 test_set_prereq C_LOCALE_OUTPUT
728 # Use this instead of test_cmp to compare files that contain expected and
729 # actual output from git commands that can be translated. When running
730 # under GETTEXT_POISON this pretends that the command produced expected
731 # results.
732 test_i18ncmp () {
733 test -n "$GETTEXT_POISON" || test_cmp "$@"
736 # Use this instead of "grep expected-string actual" to see if the
737 # output from a git command that can be translated either contains an
738 # expected string, or does not contain an unwanted one. When running
739 # under GETTEXT_POISON this pretends that the command produced expected
740 # results.
741 test_i18ngrep () {
742 if test -n "$GETTEXT_POISON"
743 then
744 : # pretend success
745 elif test "x!" = "x$1"
746 then
747 shift
748 ! grep "$@"
749 else
750 grep "$@"
754 test_lazy_prereq PIPE '
755 # test whether the filesystem supports FIFOs
756 rm -f testfifo && mkfifo testfifo
759 test_lazy_prereq SYMLINKS '
760 # test whether the filesystem supports symbolic links
761 ln -s x y && test -h y
764 test_lazy_prereq CASE_INSENSITIVE_FS '
765 echo good >CamelCase &&
766 echo bad >camelcase &&
767 test "$(cat CamelCase)" != good
770 test_lazy_prereq UTF8_NFD_TO_NFC '
771 # check whether FS converts nfd unicode to nfc
772 auml=$(printf "\303\244")
773 aumlcdiar=$(printf "\141\314\210")
774 >"$auml" &&
775 case "$(echo *)" in
776 "$aumlcdiar")
777 true ;;
779 false ;;
780 esac
783 test_lazy_prereq AUTOIDENT '
784 sane_unset GIT_AUTHOR_NAME &&
785 sane_unset GIT_AUTHOR_EMAIL &&
786 git var GIT_AUTHOR_IDENT
789 # When the tests are run as root, permission tests will report that
790 # things are writable when they shouldn't be.
791 test -w / || test_set_prereq SANITY
793 GIT_UNZIP=${GIT_UNZIP:-unzip}
794 test_lazy_prereq UNZIP '
795 "$GIT_UNZIP" -v
796 test $? -ne 127